"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Box: () => Box,
  CAN_USE_DOM: () => CAN_USE_DOM,
  DEFAULT_IGNORE_CLASS: () => DEFAULT_IGNORE_CLASS,
  PortalBody: () => PortalBody,
  Text: () => Text,
  composeEventHandlers: () => composeEventHandlers,
  composeRefs: () => composeRefs,
  createPrimitiveComponent: () => createPrimitiveComponent,
  createPrimitiveElement: () => createPrimitiveElement,
  createSlotComponent: () => createSlotComponent,
  useComposedRef: () => useComposedRef,
  useIsomorphicLayoutEffect: () => useIsomorphicLayoutEffect,
  useOnClickOutside: () => useOnClickOutside,
  useStableMemo: () => useStableMemo,
  withProviders: () => withProviders,
  withRef: () => withRef
});
module.exports = __toCommonJS(src_exports);

// src/createSlotComponent.tsx
var import_react = __toESM(require("react"));
var import_react_slot = require("@radix-ui/react-slot");
var createSlotComponent = (element) => (
  // eslint-disable-next-line react/display-name
  import_react.default.forwardRef((_a2, ref) => {
    var _b = _a2, { as, asChild = false } = _b, props = __objRest(_b, ["as", "asChild"]);
    const Comp = asChild ? import_react_slot.Slot : as || element;
    return /* @__PURE__ */ import_react.default.createElement(Comp, __spreadValues({ ref }, props));
  })
);

// src/Box.tsx
var Box = createSlotComponent("div");

// src/PortalBody.tsx
var import_react2 = __toESM(require("react"));
var import_react_dom = __toESM(require("react-dom"));
var PortalBody = ({
  children,
  element
}) => {
  const container = element || typeof window !== "undefined" ? document.body : void 0;
  if (!container) return /* @__PURE__ */ import_react2.default.createElement(import_react2.default.Fragment, null, children);
  return import_react_dom.default.createPortal(children, element || document.body);
};

// src/Text.tsx
var Text = createSlotComponent("span");

// src/composeEventHandlers.ts
var composeEventHandlers = (originalEventHandler, ourEventHandler, { checkForDefaultPrevented = true } = {}) => (event) => {
  originalEventHandler == null ? void 0 : originalEventHandler(event);
  if (checkForDefaultPrevented === false || !event.defaultPrevented) {
    return ourEventHandler == null ? void 0 : ourEventHandler(event);
  }
};

// src/createPrimitiveComponent.tsx
var import_react4 = __toESM(require("react"));
var import_utils = require("@udecode/utils");
var import_clsx = require("clsx");

// src/useComposedRef.ts
var import_react3 = __toESM(require("react"));
var setRef = (ref, value) => {
  if (typeof ref === "function") {
    ref(value);
  } else if (ref !== null && ref !== void 0) {
    ref.current = value;
  }
};
var composeRefs = (...refs) => (node) => refs.forEach((ref) => setRef(ref, node));
var useComposedRef = (...refs) => {
  return import_react3.default.useCallback(composeRefs(...refs), refs);
};

// src/createPrimitiveComponent.tsx
var createPrimitiveComponent = (element) => {
  const Comp = createSlotComponent(element);
  return ({
    propsHook,
    stateHook
  } = {}) => {
    return import_react4.default.forwardRef(
      (_a2, ref) => {
        var _b = _a2, {
          asChild,
          className: classNameProp,
          getClassName,
          options,
          state: stateProp
        } = _b, props = __objRest(_b, [
          "asChild",
          "className",
          "getClassName",
          "options",
          "state"
        ]);
        var _a3, _b2;
        const state = (0, import_utils.isDefined)(stateProp) ? stateProp : stateHook ? stateHook(options) : void 0;
        const {
          hidden,
          props: hookProps,
          ref: hookRef
        } = propsHook ? propsHook(state) : { hidden: false, props: {}, ref: null };
        const _ref = useComposedRef(ref, hookRef);
        const className = (0, import_utils.isDefined)(hookProps == null ? void 0 : hookProps.className) || (0, import_utils.isDefined)(classNameProp) ? (0, import_clsx.clsx)(hookProps == null ? void 0 : hookProps.className, classNameProp) : void 0;
        const style = (hookProps == null ? void 0 : hookProps.style) || props.style ? __spreadValues(__spreadValues({}, hookProps == null ? void 0 : hookProps.style), props.style) : void 0;
        if (!asChild && hidden) return null;
        return /* @__PURE__ */ import_react4.default.createElement(
          Comp,
          __spreadValues(__spreadValues(__spreadProps(__spreadValues({
            ref: _ref,
            asChild
          }, hookProps), {
            className,
            style
          }), props), (_b2 = (_a3 = props.setProps) == null ? void 0 : _a3.call(props, hookProps != null ? hookProps : {})) != null ? _b2 : {})
        );
      }
    );
  };
};

// src/createPrimitiveElement.tsx
var import_react5 = __toESM(require("react"));
function createPrimitiveElement(tag) {
  return import_react5.default.forwardRef(
    function CreateComponent(props, ref) {
      return import_react5.default.createElement(tag, __spreadProps(__spreadValues({}, props), { ref }));
    }
  );
}

// src/useIsomorphicLayoutEffect.ts
var import_react6 = __toESM(require("react"));
var _a;
var CAN_USE_DOM = typeof window !== "undefined" && ((_a = window.document) == null ? void 0 : _a.createElement) !== void 0;
var useIsomorphicLayoutEffect = CAN_USE_DOM ? import_react6.default.useLayoutEffect : import_react6.default.useEffect;

// src/useOnClickOutside.ts
var import_react7 = __toESM(require("react"));
var canUsePassiveEvents = () => {
  if (typeof window === "undefined" || typeof window.addEventListener !== "function")
    return false;
  let passive = false;
  const options = Object.defineProperty({}, "passive", {
    // eslint-disable-next-line getter-return
    get() {
      passive = true;
    }
  });
  const noop = () => null;
  window.addEventListener("test", noop, options);
  window.removeEventListener("test", noop, options);
  return passive;
};
var DEFAULT_IGNORE_CLASS = "ignore-onclickoutside";
var checkClass = (el, cl) => {
  var _a2;
  return (_a2 = el.classList) == null ? void 0 : _a2.contains(cl);
};
var hasIgnoreClass = (e, ignoreClass) => {
  let el = e.target || e;
  while (el) {
    if (Array.isArray(ignoreClass)) {
      if (ignoreClass.some((c) => checkClass(el, c))) return true;
    } else if (checkClass(el, ignoreClass)) {
      return true;
    }
    el = el.parentElement;
  }
  return false;
};
var clickedOnScrollbar = (e) => document.documentElement.clientWidth <= e.clientX || document.documentElement.clientHeight <= e.clientY;
var getEventOptions = (type) => type.includes("touch") && canUsePassiveEvents() ? { passive: true } : false;
var useOnClickOutside = (callback, {
  detectIFrame = true,
  disabled,
  eventTypes = ["mousedown", "touchstart"],
  excludeScrollbar,
  ignoreClass = DEFAULT_IGNORE_CLASS,
  refs: refsOpt
} = {}) => {
  const [refsState, setRefsState] = import_react7.default.useState([]);
  const callbackRef = import_react7.default.useRef(callback);
  callbackRef.current = callback;
  const ref = import_react7.default.useCallback(
    (el) => setRefsState((prevState) => [...prevState, { current: el }]),
    []
  );
  import_react7.default.useEffect(
    () => {
      if (!(refsOpt == null ? void 0 : refsOpt.length) && refsState.length === 0) return;
      const getEls = () => {
        const els = [];
        (refsOpt || refsState).forEach(
          ({ current }) => current && els.push(current)
        );
        return els;
      };
      const handler = (e) => {
        if (!hasIgnoreClass(e, ignoreClass) && !(excludeScrollbar && clickedOnScrollbar(e)) && getEls().every((el) => !el.contains(e.target)))
          callbackRef.current(e);
      };
      const blurHandler = (e) => (
        // On firefox the iframe becomes document.activeElement in the next event loop
        setTimeout(() => {
          const { activeElement } = document;
          if ((activeElement == null ? void 0 : activeElement.tagName) === "IFRAME" && !hasIgnoreClass(activeElement, ignoreClass) && !getEls().includes(activeElement))
            callbackRef.current(e);
        }, 0)
      );
      const removeEventListener = () => {
        eventTypes.forEach(
          (type) => document.removeEventListener(
            type,
            handler,
            getEventOptions(type)
          )
        );
        if (detectIFrame) window.removeEventListener("blur", blurHandler);
      };
      if (disabled) {
        removeEventListener();
        return;
      }
      eventTypes.forEach(
        (type) => document.addEventListener(type, handler, getEventOptions(type))
      );
      if (detectIFrame) window.addEventListener("blur", blurHandler);
      return () => removeEventListener();
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [
      refsState,
      ignoreClass,
      excludeScrollbar,
      disabled,
      detectIFrame,
      // eslint-disable-next-line react-hooks/exhaustive-deps
      JSON.stringify(eventTypes)
    ]
  );
  return ref;
};

// src/useStableMemo.ts
var import_react8 = __toESM(require("react"));
var useStableMemo = (producer, deps) => {
  const [value, setValue] = import_react8.default.useState(producer);
  import_react8.default.useLayoutEffect(() => {
    setValue(producer);
  }, deps);
  return value;
};

// src/withProviders.tsx
var import_react9 = __toESM(require("react"));
var withProviders = (...providers) => (WrappedComponent) => (props) => providers.reduceRight(
  (acc, prov) => {
    let Provider = prov;
    if (Array.isArray(prov)) {
      [Provider] = prov;
      return /* @__PURE__ */ import_react9.default.createElement(Provider, __spreadValues({}, prov[1]), acc);
    }
    return /* @__PURE__ */ import_react9.default.createElement(Provider, null, acc);
  },
  /* @__PURE__ */ import_react9.default.createElement(WrappedComponent, __spreadValues({}, props))
);

// src/withRef.tsx
var import_react10 = __toESM(require("react"));
function withRef(renderFunction) {
  return import_react10.default.forwardRef(renderFunction);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Box,
  CAN_USE_DOM,
  DEFAULT_IGNORE_CLASS,
  PortalBody,
  Text,
  composeEventHandlers,
  composeRefs,
  createPrimitiveComponent,
  createPrimitiveElement,
  createSlotComponent,
  useComposedRef,
  useIsomorphicLayoutEffect,
  useOnClickOutside,
  useStableMemo,
  withProviders,
  withRef
});
//# sourceMappingURL=index.js.map